/*
 * FuelCalcMidlet.java
 *
 * Created on 14  2006 ., 23:59
 */

package CarCalc;

import javax.microedition.midlet.*;
import javax.microedition.lcdui.*;
import javax.microedition.rms.*;
import javax.microedition.io.*;
import java.io.*;
import java.util.*;



/**
 *
 * @author Ivan
 */
public class FuelCalcMidlet 
        extends MIDlet 
        implements javax.microedition.lcdui.CommandListener, 
                   javax.microedition.lcdui.ItemCommandListener,
                   javax.microedition.lcdui.ItemStateListener,
                   javax.microedition.rms.RecordComparator
{

    private Display     display;
    private RecordStore rsFills  = null; 
    private Vector      vRefuels = null;
    
    /**
     * Creates a new instance of FuelCalcMidlet 
     */
    public FuelCalcMidlet() 
    {
          display = Display.getDisplay(this);
          vRefuels = new Vector();
    }
//------------------------------------------------------------------------------    
    boolean FieldEnabled(TextField tf)
    {
        return (tf.getConstraints() & TextField.UNEDITABLE)==0;
    }
//------------------------------------------------------------------------------    
    public void itemStateChanged(Item item) 
    {
        TextField tfSum = get_txtSumm();
        TextField tfLiters = get_txtLiters();
        int iConstr;
        if(item!=tfSum && item!=tfLiters && item!=get_txtPrice())
        {
            return;
        }
        String strLiters = tfLiters.getString();
        String strSum = tfSum.getString();
        if(FieldEnabled(tfLiters))
        {
            
            if(strLiters.length()!=0)
            {
               iConstr = tfSum.getConstraints();
               iConstr|= TextField.UNEDITABLE;
               try
               {
                    tfSum.setConstraints(iConstr);
               } catch(Exception e){}
               tfSum.setString("");
               try
               {
                    float fLiters = Float.parseFloat(strLiters);
                    float fPrice = Float.parseFloat(get_txtPrice().getString());
                    float fSum = (int)(fLiters*fPrice*100);
                    fSum /=100;
                    if(fSum>0.0)
                    {
                        tfSum.setString(Float.toString(fSum));
                    }
               }
               catch(Exception e)
               {
                   //nothing
               }
            }
            else
            {
                iConstr = tfSum.getConstraints();
                iConstr&= ~TextField.UNEDITABLE;
               try
               {
                    tfSum.setConstraints(iConstr);
               } catch(Exception e){}

                if(item==tfLiters)
                {
                    tfSum.setString("");
                    return;
                }
                
            }
        }
        if(FieldEnabled(tfSum))
        {
            tfLiters.setString("");
            if(strSum.length()!=0)
            {
               iConstr = tfLiters.getConstraints();
               iConstr|= TextField.UNEDITABLE;
               try
               {
                    tfLiters.setConstraints(iConstr);
               } catch(Exception e){}
               
               
               try
               {
                    float fPrice = Float.parseFloat(get_txtPrice().getString());
                    if(fPrice>0.0)
                    {
                        float fSum = Float.parseFloat(strSum);               
                        float fLiters = (int)(10*fSum/fPrice);
                        fLiters /=10;
                        if(fLiters>0.0)
                        {
                            tfLiters.setString(Float.toString(fLiters));
                        } 
                    }
               }
               catch(Exception e)
               {
                   //nothing
               }
            }
            else
            {
                iConstr = tfLiters.getConstraints();
                iConstr&= ~TextField.UNEDITABLE;
                try
                {
                    tfLiters.setConstraints(iConstr);
                } catch(Exception e){}
            }
        }
    }
//------------------------------------------------------------------------------    
    public void errorMsg (String strError) 
    {
        Alert a = new Alert(":", strError, null, AlertType.ERROR);
        a.setTimeout(3000);
        display.setCurrent(a);  
    }
//------------------------------------------------------------------------------
    private boolean PendRefillRecord()
    {      
        int     iOdometer = 0;
        float   fLiters   = 0;
        long    lDate     = 0;
        float   fPrice    = 0;
        String  strRemark = "";        

        try
        {          
            iOdometer = Integer.parseInt(get_txtOdometer().getString());
            
            lDate     = get_dtFillDate().getDate().getTime();
            fPrice    = Float.parseFloat(get_txtPrice().getString());
            strRemark = get_txtRemark().getString();
//            if((get_txtSumm().getConstraints() & TextField.UNEDITABLE)==0 &&  get_txtSumm().getString().length()>0)
//            {
//                float fSum = (int)(Float.parseFloat(get_txtSumm().getString())*100);
//                fLiters = (fSum/fPrice)/100;
//            }
//            else
//            {
                fLiters   = Float.parseFloat(get_txtLiters().getString());
//            }
            
        }
        catch(NumberFormatException e)
        {
            errorMsg (" !");
            return false;
        }
        
        Refuel objRefuel;
        if(vRefuels.size()>0)
        {
           objRefuel = (Refuel) vRefuels.lastElement();
           if(objRefuel.iOdometer>=iOdometer)
           {
               errorMsg (" !");
               return false;
           }
           if(objRefuel.lDate>lDate)
           {
               errorMsg (" !");
               return false;
           }
           if(objRefuel.fPrice<=0.0)
           {
               errorMsg (" !");
               return false;
           }
           if(objRefuel.fLiters<=0.0)
           {
               errorMsg ("  !");
               return false;
           }          
        }
        fLiters = (int)(fLiters*10.0);
        fLiters /=10;
        objRefuel = new Refuel(iOdometer, lDate, fLiters, fPrice, strRemark);
        if(objRefuel!=null)
        {
            vRefuels.addElement(objRefuel);
        }
        objRefuel = null;
        return true;
    }
//------------------------------------------------------------------------------    
    private void BeforeEditRefillAction()
    {
        //todo: complete it;
    }
    
    private void BeforeNewRefillAction()
    {
        DateField df=get_dtFillDate();
        Date d = new Date();
        df.setDate(d);
        d = null;

        Refuel objRefuel;
        try
        {
            objRefuel = (Refuel) vRefuels.lastElement();
            TextField tf = get_txtPrice();
            tf.setString(Float.toString(objRefuel.fPrice));
            tf = get_txtLiters();
            tf.setString(Float.toString(objRefuel.fLiters));            
            get_txtSumm().setString("");
            int iOdometer=0;
            int iCount = vRefuels.size();
            if(iCount>1)
            {
                Refuel objRefuel2 = (Refuel) vRefuels.firstElement();
                iOdometer = objRefuel.iOdometer+(objRefuel.iOdometer-objRefuel2.iOdometer)/iCount;
                iOdometer /=100;
            }
            else
            {
                iOdometer = objRefuel.iOdometer/1000;
            }
            get_txtOdometer().setString(Integer.toString(iOdometer));
            objRefuel = null;
        }
        catch(NoSuchElementException e)
        {
            //nothing
        }
        itemStateChanged(get_txtPrice());
    }
//------------------------------------------------------------------------------    
    public int compare(byte[] rec1, byte[] rec2)
    {
//        ByteArrayInputStream bais1 = new ByteArrayInputStream(rec1);
//        ByteArrayInputStream bais2 = new ByteArrayInputStream(rec2);

        return EQUIVALENT;
    }
//------------------------------------------------------------------------------    
    public void LoadFills()
    {        
        try 
        {
            rsFills = RecordStore.openRecordStore ("Refuels.dat", false);
        }
        catch (RecordStoreException e) 
        { // general error
            rsFills=null; 
            return;
        } 
        if (rsFills!=null) 
        {
            //vRefuels;
            boolean bRes = true;
            int iId = 1;
            Refuel objRefuel = null;
/*            
            RecordEnumeration  re = null;
            int iRecordCount = 0;
            
            try
            {
                iRecordCount = rsFills.getNumRecords();
                re = rsFills.enumerateRecords(null, this, false);
                for(int i=0;i<iRecordCount;i++)
                {
                    objRefuel = new Refuel();
                    bRes = objRefuel.LoadFromRecordStore(re.nextRecordId(), rsFills);
                    if(bRes)
                    {
                        vRefuels.addElement(objRefuel);
                    }
                    objRefuel = null;           
                }
            }
            catch(Exception e)
            {
                errorMsg("  ");
            }
*/
           
            while(bRes)
            {
                objRefuel = new Refuel();
                bRes = objRefuel.LoadFromRecordStore(iId, rsFills);
                if(bRes)
                {
                    vRefuels.addElement(objRefuel);
                }
                objRefuel = null;
                iId++;
            }

            try
            {
                rsFills.closeRecordStore();
            }
            catch(RecordStoreException ex){}         
            rsFills = null;
            
        }
    }
//------------------------------------------------------------------------------    
    public void saveFills () 
    {
        int iRecordsCount = 0;
        Refuel objRefuel = null;
        try 
        {
            rsFills = RecordStore.openRecordStore ("Refuels.dat", true);
            iRecordsCount = rsFills.getNumRecords();
        }
        catch (RecordStoreFullException e) 
        { // no room left for more data
            errorMsg("    ");
            rsFills=null; 
            return;
        }
        catch (RecordStoreNotOpenException e) 
        { // store has been closed
            errorMsg("   ");   
            rsFills=null; 
            return;
        }
        catch (RecordStoreException e) 
        { // general error
            errorMsg("   ");
            rsFills=null; 
            return;
        } 
        if (rsFills!=null) 
        {
           
            int iCount = vRefuels.size();
            int i;           
            for(i=0; i<iCount; i++)
            {
                objRefuel = (Refuel) vRefuels.elementAt(i);
                if(!objRefuel.SaveToRecordStore(i+1, rsFills))
                {
                    //todo: error message
                    errorMsg(" 2    !");   
                    break;
                }                
            }
            objRefuel = new Refuel();
            objRefuel.SaveToRecordStore(i+1, rsFills);//just as eof with zeros
            objRefuel= null;
            try
            {
                rsFills.closeRecordStore();
            }
            catch(RecordStoreException ex){}         
            rsFills = null;
        }

    }
//------------------------------------------------------------------------------        
    public String oNum(int value) 
    {
        if (value<10 ) return new String("0"+value); 
        else return new String(""+value);
    }
//------------------------------------------------------------------------------        
    private String FormatDate(long lDate)
    {
        String strResult;
        Calendar cal = Calendar.getInstance();
        Date dt = new Date(lDate);
        cal.setTime(dt);
        strResult = oNum(cal.get(cal.DAY_OF_MONTH))+"."+ oNum(1+cal.get(cal.MONTH))+"."+oNum(cal.get(cal.YEAR)-2000);
        dt = null;
        return strResult;
    }
    private void PrepareRefuelList()
    {
        List lst=get_lstRefuels();
        lst.deleteAll();
        int iCount = vRefuels.size();
        Refuel objRefuel = null;
        String strItemText;        
        
        for(int i=0;i<iCount;i++)
        {
            objRefuel = (Refuel) vRefuels.elementAt(i);
            strItemText = FormatDate(objRefuel.lDate)+" "+ Integer.toString(objRefuel.iOdometer);
            lst.append(strItemText, null);
            strItemText = null;
        }
    }
    private void BeforeShowSelectedRefuel()
    {
        List lst = get_lstRefuels();
        int index = lst.getSelectedIndex();
        if(index>=0)
        {
            Refuel objRefuel;
            objRefuel = (Refuel) vRefuels.elementAt(index);
            String str; 

            str = FormatDate(objRefuel.lDate)+" "+ Integer.toString(objRefuel.iOdometer);
            get_strDateOdometer().setText(str);
            float fSum = (int)((objRefuel.fPrice*objRefuel.fLiters)*100);
            fSum/=100.0;
            str = Float.toString(objRefuel.fLiters)+"*"+Float.toString(objRefuel.fPrice)+"="+Float.toString(fSum);
            get_strPriceLiters().setText(str);
            get_strRemark().setText(objRefuel.strRemark);
            str = "";
            if(index>0)
            {
                Refuel objRefuelPrev = (Refuel) vRefuels.elementAt(index-1);
                int iTrip =  objRefuel.iOdometer - objRefuelPrev.iOdometer;
                float fConsumption = (int)((10000*objRefuel.fLiters / iTrip));
                fConsumption/=100.0;
                str = Integer.toString(iTrip)+", "+Float.toString(fConsumption)+" /100";
            }
            get_strLocalStat().setText(str);
        }
    }
    private void DeleteAllRecords()
    {
        vRefuels.removeAllElements();
        try
        {
            RecordStore.deleteRecordStore("Refuels.dat");
        }
        catch(Exception e){}
    }            
    private void PrepareStatistic()
    {
        int iSize = vRefuels.size();
        if(iSize<2) return;

        int   iTotalTrip     = 0;
        double dblTotalLiter = 0;
        double dblTotalConsumption = 0;
        double dblTotalCost = 0;
        float  fOneKmPrice;
        float  fOneLtPrice;
        float  fKmPerDay;
        long   lDays;
        Refuel objRefuel;      
        iSize-=1;//last refuel is need not
        for(int i=0;i<iSize;i++)
        {
            objRefuel = (Refuel) vRefuels.elementAt(i);
            dblTotalLiter += objRefuel.fLiters;
            dblTotalCost += objRefuel.fPrice*objRefuel.fLiters;
        }
        dblTotalCost = (long)(dblTotalCost*100.0);
        dblTotalCost /=100.0;
        dblTotalLiter = (long)(dblTotalLiter*10.0);
        dblTotalLiter /=10.0;
        Refuel r1 = (Refuel) vRefuels.firstElement();
        Refuel r2 = (Refuel) vRefuels.lastElement();
        iTotalTrip = r2.iOdometer -r1.iOdometer;
        dblTotalConsumption =  (int)((10000*dblTotalLiter / iTotalTrip));
        dblTotalConsumption /=100.0;

        fOneKmPrice = (int)(100*dblTotalCost/iTotalTrip); 
        fOneKmPrice /= 100;
        fOneLtPrice  = (int)(100*dblTotalCost/dblTotalLiter); 
        fOneLtPrice /= 100;
        lDays = (r2.lDate - r1.lDate)/86400000;
        if(lDays==0)lDays=1;
        fKmPerDay = (10*iTotalTrip)/lDays;
        fKmPerDay/=10;
        get_strTotalRun().setText(Integer.toString(iTotalTrip));
        get_strTotalPeriod().setText(FormatDate(r1.lDate)+"-"+ FormatDate(r2.lDate));
        get_strTotalLiter().setText(Double.toString(dblTotalLiter));
        get_strTotalConsumption().setText(Double.toString(dblTotalConsumption ));
        get_strTotalCost().setText(Double.toString(dblTotalCost ));
        
        get_strTotalOneLiterPrice().setText(Float.toString(fOneLtPrice));
        get_strTotalOneKmPrice().setText(Float.toString(fOneKmPrice));
        get_strTotalKmPerDay().setText(Float.toString(fKmPerDay));
    }
    
    private void DeleteSelectedListItem()
    {
        List lst = get_lstRefuels();
        int index = lst.getSelectedIndex();        
        if(index>=0)
        {
            lst.delete(index);
            vRefuels.removeElementAt(index);
        }
        
    }
    
    private void DeleteLastItem()
    {
        List lst = get_lstRefuels();
        int index = lst.size()-1;
        if(index>=0)
        {
            lst.delete(index);
            vRefuels.removeElementAt(index);
        }    
        
    }
// --- This section is auto-generated by NetBeans IDE. Do not modify or you may lose your changes.//<editor-fold id="MVDMethods" defaultstate="collapsed" desc="This section is auto-generated by NetBeans IDE.">//GEN-BEGIN:MVDMethods
    /**
     * This method initializes UI of the application.
     */
    private void initialize() {
// For adding user code into this block, select "Design" item in the inspector and invoke property editor on Action property in Properties window.
        javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
    }
    
    /**
     * Called by the system to indicate that a command has been invoked on a particular displayable.
     * @param command the Command that ws invoked
     * @param displayable the Displayable on which the command was invoked
     **/
    public void commandAction(javax.microedition.lcdui.Command command, javax.microedition.lcdui.Displayable displayable) {
        if (displayable == formAbout) {
            if (command == cmdBack) {
// For adding user code into this block, select "Design | Screens | formAbout [Form] | Assigned Commands | cmdBack" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formOptions());
            }
        } else if (displayable == formAlert) {
            if (command == cmdCancel) {
// For adding user code into this block, select "Design | Screens | formAlert [Form] | Assigned Commands | cmdCancel" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formOptions());
            } else if (command == cmdOk) {
// For adding user code into this block, select "Design | Screens | formAlert [Form] | Assigned Commands | cmdOk" item in the inspector and invoke property editor on Action property in Properties window.
                DeleteAllRecords();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formOptions());
            }
        } else if (displayable == formAlertDelItem) {
            if (command == cmdCancel) {
// For adding user code into this block, select "Design | Screens | formAlertDelItem [Form] | Assigned Commands | cmdCancel" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_lstRefuels());
            } else if (command == cmdOk) {
// For adding user code into this block, select "Design | Screens | formAlertDelItem [Form] | Assigned Commands | cmdOk" item in the inspector and invoke property editor on Action property in Properties window.
                DeleteLastItem();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_lstRefuels());
            }
        } else if (displayable == formDispRefuel) {
            if (command == cmdBack) {
// For adding user code into this block, select "Design | Screens | formDispRefuel [Form] | Assigned Commands | cmdBack" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_lstRefuels());
            }
        } else if (displayable == formFillEdit) {
            if (command == cmdCancel) {
// For adding user code into this block, select "Design | Screens | formFillEdit [Form] | Assigned Commands | cmdCancel" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
            } else if (command == cmdOk) {
// For adding user code into this block, select "Design | Screens | formFillEdit [Form] | Assigned Commands | cmdOk" item in the inspector and invoke property editor on Action property in Properties window.
                if(PendRefillRecord())
                    javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
            }
        } else if (displayable == formStatistic) {
            if (command == cmdBack) {
// For adding user code into this block, select "Design | Screens | formStatistic [Form] | Assigned Commands | cmdBack" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
            }
        } else if (displayable == lstRefuels) {
            if (command == cmdBack) {
// For adding user code into this block, select "Design | Screens | lstRefuels [List] | Assigned Commands | cmdBack" item in the inspector and invoke property editor on Action property in Properties window.
                get_lstRefuels().deleteAll();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
            } else if (command == cmdDelItem) {
// For adding user code into this block, select "Design | Screens | lstRefuels [List] | Assigned Commands | cmdDelItem" item in the inspector and invoke property editor on Action property in Properties window.
                List lst = get_lstRefuels();
                if(lst.size()>0)
                    javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formAlertDelItem());
            } else if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | lstRefuels [List] | Assigned Commands | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                BeforeShowSelectedRefuel();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formDispRefuel());
            }
        }
    }
    
    /**
     * Called by the system to indicate that a command has been invoked on a particular item.
     * @param command the Command that ws invoked
     * @param item the Item on which the command was invoked
     **/
    public void commandAction(javax.microedition.lcdui.Command command, javax.microedition.lcdui.Item item) {
        if (item == strExit) {
            if (command == exitCommand) {
// For adding user code into this block, select "Design | Screens | formMain [Form] | Items | strExit [StringItem] | Assigned Command | exitCommand" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(null);
                destroyApp(true);
                notifyDestroyed();
            }
        } else if (item == strNewFill) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formMain [Form] | Items | strNewFill [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                BeforeNewRefillAction();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formFillEdit());
                Display.getDisplay(this).setCurrentItem(get_txtOdometer());
            }
        } else if (item == strOpAbout) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formOptions [Form] | Items | strOpAbout [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formAbout());
            }
        } else if (item == strOptBack) {
            if (command == cmdBack) {
// For adding user code into this block, select "Design | Screens | formOptions [Form] | Items | strOptBack [StringItem] | Assigned Command | cmdBack" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formMain());
            }
        } else if (item == strOptDeleteAll) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formOptions [Form] | Items | strOptDeleteAll [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formAlert());
            }
        } else if (item == strOptions) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formMain [Form] | Items | strOptions [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formOptions());
            }
        } else if (item == strRefuelList) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formMain [Form] | Items | strRefuelList [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                PrepareRefuelList();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_lstRefuels());
            }
        } else if (item == strStatistic) {
            if (command == cmdOpen) {
// For adding user code into this block, select "Design | Screens | formMain [Form] | Items | strStatistic [StringItem] | Assigned Command | cmdOpen" item in the inspector and invoke property editor on Action property in Properties window.
                PrepareStatistic();
                javax.microedition.lcdui.Display.getDisplay(this).setCurrent(get_formStatistic());
            }
        }
    }
    
    /**
     * This method returns instance for formMain component and should be called instead of accessing formMain field directly.
     * @return Instance for formMain component
     **/
    private javax.microedition.lcdui.Form get_formMain() {
        if (formMain == null) {
            formMain = new javax.microedition.lcdui.Form("\u0420\u0430\u0441\u0445\u043E\u0434 \u0442\u043E\u043F\u043B\u0438\u0432\u0430", new javax.microedition.lcdui.Item[] {
                get_strNewFill(),
                        get_strRefuelList(),
                        get_strStatistic(),
                        get_strOptions(),
                        get_strExit()
            });
        }
        return formMain;
    }
    
    /**
     * This method returns instance for strNewFill component and should be called instead of accessing strNewFill field directly.
     * @return Instance for strNewFill component
     **/
    private javax.microedition.lcdui.StringItem get_strNewFill() {
        if (strNewFill == null) {
            strNewFill = new javax.microedition.lcdui.StringItem("", "\u041D\u043E\u0432\u0430\u044F \u0437\u0430\u043F\u0440\u0430\u0432\u043A\u0430");
            strNewFill.addCommand(get_cmdOpen());
            strNewFill.setItemCommandListener(this);
            strNewFill.setLayout(0x1a03);
        }
        return strNewFill;
    }
    
    /**
     * This method returns instance for exitCommand component and should be called instead of accessing exitCommand field directly.
     * @return Instance for exitCommand component
     **/
    private javax.microedition.lcdui.Command get_exitCommand() {
        if (exitCommand == null) {
            exitCommand = new javax.microedition.lcdui.Command("\u0412\u044B\u0445\u043E\u0434", "\u0412\u044B\u0445\u043E\u0434", javax.microedition.lcdui.Command.EXIT, 1);
        }
        return exitCommand;
    }
    
    /**
     * This method returns instance for formFillEdit component and should be called instead of accessing formFillEdit field directly.
     * @return Instance for formFillEdit component
     **/
    private javax.microedition.lcdui.Form get_formFillEdit() {
        if (formFillEdit == null) {
            formFillEdit = new javax.microedition.lcdui.Form("\u043D\u043E\u0432\u0430\u044F \u0437\u0430\u043F\u0440\u0430\u0432\u043A\u0430:", new javax.microedition.lcdui.Item[] {
                get_dtFillDate(),
                        get_txtOdometer(),
                        get_txtLiters(),
                        get_txtPrice(),
                        get_txtSumm(),
                        get_txtRemark()
            });
            formFillEdit.addCommand(get_cmdOk());
            formFillEdit.addCommand(get_cmdCancel());
            formFillEdit.setCommandListener(this);
            formFillEdit.setItemStateListener(this);
        }
        return formFillEdit;
    }
    
    /**
     * This method returns instance for txtOdometer component and should be called instead of accessing txtOdometer field directly.
     * @return Instance for txtOdometer component
     **/
    private javax.microedition.lcdui.TextField get_txtOdometer() {
        if (txtOdometer == null) {
            txtOdometer = new javax.microedition.lcdui.TextField("\u041E\u0434\u043E\u043C\u0435\u0442\u0440:", "", 6, 0x2);
            txtOdometer.setLayout(0xc01);
            txtOdometer.setInitialInputMode("");
        }
        return txtOdometer;
    }
    
    /**
     * This method returns instance for cmdOk component and should be called instead of accessing cmdOk field directly.
     * @return Instance for cmdOk component
     **/
    private javax.microedition.lcdui.Command get_cmdOk() {
        if (cmdOk == null) {
            cmdOk = new javax.microedition.lcdui.Command("\u041E\u041A", "\u041E\u041A", javax.microedition.lcdui.Command.OK, 1);
        }
        return cmdOk;
    }
    
    /**
     * This method returns instance for cmdCancel component and should be called instead of accessing cmdCancel field directly.
     * @return Instance for cmdCancel component
     **/
    private javax.microedition.lcdui.Command get_cmdCancel() {
        if (cmdCancel == null) {
            cmdCancel = new javax.microedition.lcdui.Command("\u041E\u0442\u043C\u0435\u043D\u0430", javax.microedition.lcdui.Command.CANCEL, 1);
        }
        return cmdCancel;
    }
    
    /**
     * This method returns instance for txtLiters component and should be called instead of accessing txtLiters field directly.
     * @return Instance for txtLiters component
     **/
    private javax.microedition.lcdui.TextField get_txtLiters() {
        if (txtLiters == null) {
            txtLiters = new javax.microedition.lcdui.TextField("\u041B\u0438\u0442\u0440\u044B:", "", 6, 0x5);
            txtLiters.setLayout(0xc01);
            txtLiters.setInitialInputMode("");
        }
        return txtLiters;
    }
    
    /**
     * This method returns instance for strExit component and should be called instead of accessing strExit field directly.
     * @return Instance for strExit component
     **/
    private javax.microedition.lcdui.StringItem get_strExit() {
        if (strExit == null) {
            strExit = new javax.microedition.lcdui.StringItem("", "\u0412\u044B\u0445\u043E\u0434");
            strExit.addCommand(get_exitCommand());
            strExit.setItemCommandListener(this);
            strExit.setLayout(0x1b03);
            strExit.setDefaultCommand(get_exitCommand());
        }
        return strExit;
    }
    
    /**
     * This method returns instance for txtPrice component and should be called instead of accessing txtPrice field directly.
     * @return Instance for txtPrice component
     **/
    private javax.microedition.lcdui.TextField get_txtPrice() {
        if (txtPrice == null) {
            txtPrice = new javax.microedition.lcdui.TextField("\u0426\u0435\u043D\u0430:", "", 6, 0x5);
            txtPrice.setLayout(0xc01);
        }
        return txtPrice;
    }
    
    /**
     * This method returns instance for dtFillDate component and should be called instead of accessing dtFillDate field directly.
     * @return Instance for dtFillDate component
     **/
    private javax.microedition.lcdui.DateField get_dtFillDate() {
        if (dtFillDate == null) {
            dtFillDate = new javax.microedition.lcdui.DateField("\u0414\u0430\u0442\u0430:", javax.microedition.lcdui.DateField.DATE);
            dtFillDate.setLayout(0xc31);
        }
        return dtFillDate;
    }
    
    /**
     * This method returns instance for txtRemark component and should be called instead of accessing txtRemark field directly.
     * @return Instance for txtRemark component
     **/
    private javax.microedition.lcdui.TextField get_txtRemark() {
        if (txtRemark == null) {
            txtRemark = new javax.microedition.lcdui.TextField("\u041F\u0440\u0438\u043C\u0435\u0447\u0430\u043D\u0438\u0435", "", 120, 0x0);
            txtRemark.setLayout(0xc01);
            txtRemark.setInitialInputMode("");
        }
        return txtRemark;
    }
    
    /**
     * This method returns instance for fontMonospace component and should be called instead of accessing fontMonospace field directly.
     * @return Instance for fontMonospace component
     **/
    private javax.microedition.lcdui.Font get_fontMonospace() {
        if (fontMonospace == null) {
            fontMonospace = javax.microedition.lcdui.Font.getFont(javax.microedition.lcdui.Font.FACE_MONOSPACE, 0x0, javax.microedition.lcdui.Font.SIZE_MEDIUM);
        }
        return fontMonospace;
    }
    
    /**
     * This method returns instance for lstRefuels component and should be called instead of accessing lstRefuels field directly.
     * @return Instance for lstRefuels component
     **/
    private javax.microedition.lcdui.List get_lstRefuels() {
        if (lstRefuels == null) {
            lstRefuels = new javax.microedition.lcdui.List("\u0432\u0441\u0435 \u0437\u0430\u043F\u0440\u0430\u0432\u043A\u0438", javax.microedition.lcdui.Choice.IMPLICIT, new java.lang.String[0], new javax.microedition.lcdui.Image[0]);
            lstRefuels.addCommand(get_cmdOpen());
            lstRefuels.addCommand(get_cmdBack());
            lstRefuels.addCommand(get_cmdDelItem());
            lstRefuels.setCommandListener(this);
            lstRefuels.setSelectedFlags(new boolean[0]);
            lstRefuels.setSelectCommand(get_cmdOpen());
            lstRefuels.setFitPolicy(javax.microedition.lcdui.Choice.TEXT_WRAP_OFF);
        }
        return lstRefuels;
    }
    
    /**
     * This method returns instance for strRefuelList component and should be called instead of accessing strRefuelList field directly.
     * @return Instance for strRefuelList component
     **/
    private javax.microedition.lcdui.StringItem get_strRefuelList() {
        if (strRefuelList == null) {
            strRefuelList = new javax.microedition.lcdui.StringItem("", "\u0421\u043F\u0438\u0441\u043E\u043A");
            strRefuelList.addCommand(get_cmdOpen());
            strRefuelList.setItemCommandListener(this);
            strRefuelList.setLayout(0x1b03);
        }
        return strRefuelList;
    }
    
    /**
     * This method returns instance for strStatistic component and should be called instead of accessing strStatistic field directly.
     * @return Instance for strStatistic component
     **/
    private javax.microedition.lcdui.StringItem get_strStatistic() {
        if (strStatistic == null) {
            strStatistic = new javax.microedition.lcdui.StringItem("", "\u0421\u0442\u0430\u0442\u0438\u0441\u0442\u0438\u043A\u0430");
            strStatistic.addCommand(get_cmdOpen());
            strStatistic.setItemCommandListener(this);
            strStatistic.setLayout(0x1b03);
        }
        return strStatistic;
    }
    
    /**
     * This method returns instance for cmdDelItem component and should be called instead of accessing cmdDelItem field directly.
     * @return Instance for cmdDelItem component
     **/
    private javax.microedition.lcdui.Command get_cmdDelItem() {
        if (cmdDelItem == null) {
            cmdDelItem = new javax.microedition.lcdui.Command("\u0423\u0434. \u043F\u043E\u0441\u043B.", "\u0423\u0434\u0430\u043B\u0438\u0442\u044C \u043F\u043E\u0441\u043B\u0435\u0434\u043D\u0438\u0439", javax.microedition.lcdui.Command.ITEM, 7);
        }
        return cmdDelItem;
    }
    
    /**
     * This method returns instance for formAlert component and should be called instead of accessing formAlert field directly.
     * @return Instance for formAlert component
     **/
    private javax.microedition.lcdui.Form get_formAlert() {
        if (formAlert == null) {
            formAlert = new javax.microedition.lcdui.Form("\u041F\u043E\u0434\u0432\u0435\u0440\u0436\u0434\u0435\u043D\u0438\u0435", new javax.microedition.lcdui.Item[] {get_strAlertMsg()});
            formAlert.addCommand(get_cmdOk());
            formAlert.addCommand(get_cmdCancel());
            formAlert.setCommandListener(this);
        }
        return formAlert;
    }
    
    /**
     * This method returns instance for strAlertMsg component and should be called instead of accessing strAlertMsg field directly.
     * @return Instance for strAlertMsg component
     **/
    private javax.microedition.lcdui.StringItem get_strAlertMsg() {
        if (strAlertMsg == null) {
            strAlertMsg = new javax.microedition.lcdui.StringItem("", "\u0412\u0441\u0435 \u0434\u0430\u043D\u043D\u044B\u0435 \u043E \u0437\u0430\u043F\u0440\u0430\u0432\u043A\u0430\u0445 \u0431\u0443\u0434\u0443\u0442 \u0443\u0434\u0430\u043B\u0435\u043D\u044B. \u041F\u0440\u043E\u0434\u043E\u043B\u0436\u0438\u0442\u044C?");
            strAlertMsg.setLayout(0x3033);
        }
        return strAlertMsg;
    }
    
    /**
     * This method returns instance for formDispRefuel component and should be called instead of accessing formDispRefuel field directly.
     * @return Instance for formDispRefuel component
     **/
    private javax.microedition.lcdui.Form get_formDispRefuel() {
        if (formDispRefuel == null) {
            formDispRefuel = new javax.microedition.lcdui.Form("", new javax.microedition.lcdui.Item[] {
                get_strDateOdometer(),
                        get_strPriceLiters(),
                        get_strRemark(),
                        get_strLocalStat()
            });
            formDispRefuel.addCommand(get_cmdBack());
            formDispRefuel.setCommandListener(this);
        }
        return formDispRefuel;
    }
    
    /**
     * This method returns instance for cmdBack component and should be called instead of accessing cmdBack field directly.
     * @return Instance for cmdBack component
     **/
    private javax.microedition.lcdui.Command get_cmdBack() {
        if (cmdBack == null) {
            cmdBack = new javax.microedition.lcdui.Command("\u041D\u0430\u0437\u0430\u0434", "\u041D\u0430\u0437\u0430\u0434", javax.microedition.lcdui.Command.BACK, 8);
        }
        return cmdBack;
    }
    
    /**
     * This method returns instance for strDateOdometer component and should be called instead of accessing strDateOdometer field directly.
     * @return Instance for strDateOdometer component
     **/
    private javax.microedition.lcdui.StringItem get_strDateOdometer() {
        if (strDateOdometer == null) {
            strDateOdometer = new javax.microedition.lcdui.StringItem("\u0414\u0430\u0442\u0430/\u043A\u043C", " ");
            strDateOdometer.setLayout(0x200);
        }
        return strDateOdometer;
    }
    
    /**
     * This method returns instance for strPriceLiters component and should be called instead of accessing strPriceLiters field directly.
     * @return Instance for strPriceLiters component
     **/
    private javax.microedition.lcdui.StringItem get_strPriceLiters() {
        if (strPriceLiters == null) {
            strPriceLiters = new javax.microedition.lcdui.StringItem("\u0426\u0435\u043D\u0430*\u043B\u0438\u0442\u0440\u044B=\u0441\u0443\u043C\u043C\u0430", "0");
            strPriceLiters.setLayout(0x200);
        }
        return strPriceLiters;
    }
    
    /**
     * This method returns instance for strRemark component and should be called instead of accessing strRemark field directly.
     * @return Instance for strRemark component
     **/
    private javax.microedition.lcdui.StringItem get_strRemark() {
        if (strRemark == null) {
            strRemark = new javax.microedition.lcdui.StringItem("", "\u041F\u0440\u0438\u043C\u0435\u0447\u0430\u043D\u0438\u0435");
            strRemark.setLayout(0x200);
        }
        return strRemark;
    }
    
    /**
     * This method returns instance for strLocalStat component and should be called instead of accessing strLocalStat field directly.
     * @return Instance for strLocalStat component
     **/
    private javax.microedition.lcdui.StringItem get_strLocalStat() {
        if (strLocalStat == null) {
            strLocalStat = new javax.microedition.lcdui.StringItem("\u041F\u0440\u043E\u0431\u0435\u0433, \u0440\u0430\u0441\u0445\u043E\u0434", "0");
        }
        return strLocalStat;
    }
    
    /**
     * This method returns instance for formStatistic component and should be called instead of accessing formStatistic field directly.
     * @return Instance for formStatistic component
     **/
    private javax.microedition.lcdui.Form get_formStatistic() {
        if (formStatistic == null) {
            formStatistic = new javax.microedition.lcdui.Form("\u0441\u0442\u0430\u0442\u0438\u0441\u0442\u0438\u043A\u0430", new javax.microedition.lcdui.Item[] {
                get_strTotalRun(),
                        get_strTotalPeriod(),
                        get_strTotalLiter(),
                        get_strTotalCost(),
                        get_strTotalConsumption(),
                        get_strTotalOneLiterPrice(),
                        get_strTotalOneKmPrice(),
                        get_strTotalKmPerDay()
            });
            formStatistic.addCommand(get_cmdBack());
            formStatistic.setCommandListener(this);
        }
        return formStatistic;
    }
    
    /**
     * This method returns instance for strTotalRun component and should be called instead of accessing strTotalRun field directly.
     * @return Instance for strTotalRun component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalRun() {
        if (strTotalRun == null) {
            strTotalRun = new javax.microedition.lcdui.StringItem("\u041F\u0440\u043E\u0431\u0435\u0433", "");
        }
        return strTotalRun;
    }
    
    /**
     * This method returns instance for strTotalPeriod component and should be called instead of accessing strTotalPeriod field directly.
     * @return Instance for strTotalPeriod component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalPeriod() {
        if (strTotalPeriod == null) {
            strTotalPeriod = new javax.microedition.lcdui.StringItem("\u0417\u0430 \u043F\u0435\u0440\u0438\u043E\u0434", "");
        }
        return strTotalPeriod;
    }
    
    /**
     * This method returns instance for strTotalLiter component and should be called instead of accessing strTotalLiter field directly.
     * @return Instance for strTotalLiter component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalLiter() {
        if (strTotalLiter == null) {
            strTotalLiter = new javax.microedition.lcdui.StringItem("\u0412\u0441\u0435\u0433\u043E \u0433\u043E\u0440\u044E\u0447\u0435\u0433\u043E", "0");
        }
        return strTotalLiter;
    }
    
    /**
     * This method returns instance for strTotalConsumption component and should be called instead of accessing strTotalConsumption field directly.
     * @return Instance for strTotalConsumption component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalConsumption() {
        if (strTotalConsumption == null) {
            strTotalConsumption = new javax.microedition.lcdui.StringItem("\u0421\u0440. \u0440\u0430\u0441\u0445\u043E\u0434", "0");
        }
        return strTotalConsumption;
    }
    
    /**
     * This method returns instance for strTotalCost component and should be called instead of accessing strTotalCost field directly.
     * @return Instance for strTotalCost component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalCost() {
        if (strTotalCost == null) {
            strTotalCost = new javax.microedition.lcdui.StringItem("\u0418\u0441\u0442\u0440\u0430\u0447\u0435\u043D\u043E", "0");
        }
        return strTotalCost;
    }
    
    /**
     * This method returns instance for cmdOpen component and should be called instead of accessing cmdOpen field directly.
     * @return Instance for cmdOpen component
     **/
    private javax.microedition.lcdui.Command get_cmdOpen() {
        if (cmdOpen == null) {
            cmdOpen = new javax.microedition.lcdui.Command("\u041E\u0442\u043A\u0440.", "\u041E\u0442\u043A\u0440\u044B\u0442\u044C", javax.microedition.lcdui.Command.OK, 1);
        }
        return cmdOpen;
    }
    
    /**
     * This method returns instance for strOptions component and should be called instead of accessing strOptions field directly.
     * @return Instance for strOptions component
     **/
    private javax.microedition.lcdui.StringItem get_strOptions() {
        if (strOptions == null) {
            strOptions = new javax.microedition.lcdui.StringItem("", "\u041D\u0430\u0441\u0442\u0440\u043E\u0439\u043A\u0438");
            strOptions.addCommand(get_cmdOpen());
            strOptions.setItemCommandListener(this);
            strOptions.setLayout(0x1b03);
        }
        return strOptions;
    }
    
    /**
     * This method returns instance for formOptions component and should be called instead of accessing formOptions field directly.
     * @return Instance for formOptions component
     **/
    private javax.microedition.lcdui.Form get_formOptions() {
        if (formOptions == null) {
            formOptions = new javax.microedition.lcdui.Form("\u043D\u0430\u0441\u0442\u0440\u043E\u0439\u043A\u0438", new javax.microedition.lcdui.Item[] {
                get_strOptDeleteAll(),
                        get_strOpAbout(),
                        get_strOptBack()
            });
        }
        return formOptions;
    }
    
    /**
     * This method returns instance for strOptDeleteAll component and should be called instead of accessing strOptDeleteAll field directly.
     * @return Instance for strOptDeleteAll component
     **/
    private javax.microedition.lcdui.StringItem get_strOptDeleteAll() {
        if (strOptDeleteAll == null) {
            strOptDeleteAll = new javax.microedition.lcdui.StringItem("", "\u0421\u0442\u0435\u0440\u0435\u0442\u044C \u0432\u0441\u0435 \u0437\u0430\u043F\u0438\u0441\u0438.");
            strOptDeleteAll.addCommand(get_cmdOpen());
            strOptDeleteAll.setItemCommandListener(this);
            strOptDeleteAll.setLayout(0x1a03);
        }
        return strOptDeleteAll;
    }
    
    /**
     * This method returns instance for strOptBack component and should be called instead of accessing strOptBack field directly.
     * @return Instance for strOptBack component
     **/
    private javax.microedition.lcdui.StringItem get_strOptBack() {
        if (strOptBack == null) {
            strOptBack = new javax.microedition.lcdui.StringItem("", "\u041D\u0430\u0437\u0430\u0434");
            strOptBack.addCommand(get_cmdBack());
            strOptBack.setItemCommandListener(this);
            strOptBack.setLayout(0x1a03);
        }
        return strOptBack;
    }
    
    /**
     * This method returns instance for strTotalOneLiterPrice component and should be called instead of accessing strTotalOneLiterPrice field directly.
     * @return Instance for strTotalOneLiterPrice component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalOneLiterPrice() {
        if (strTotalOneLiterPrice == null) {
            strTotalOneLiterPrice = new javax.microedition.lcdui.StringItem("\u0421\u0440. \u0446\u0435\u043D\u0430 \u043B\u0438\u0442\u0440\u0430", "0");
        }
        return strTotalOneLiterPrice;
    }
    
    /**
     * This method returns instance for strTotalOneKmPrice component and should be called instead of accessing strTotalOneKmPrice field directly.
     * @return Instance for strTotalOneKmPrice component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalOneKmPrice() {
        if (strTotalOneKmPrice == null) {
            strTotalOneKmPrice = new javax.microedition.lcdui.StringItem("\u0421\u0440. \u0441\u0442\u043E\u0438\u043C 1 \u043A\u043C", "0");
        }
        return strTotalOneKmPrice;
    }
    
    /**
     * This method returns instance for cmdEdit component and should be called instead of accessing cmdEdit field directly.
     * @return Instance for cmdEdit component
     **/
    private javax.microedition.lcdui.Command get_cmdEdit() {
        if (cmdEdit == null) {
            cmdEdit = new javax.microedition.lcdui.Command("\u0418\u0437\u043C.", "\u0418\u0437\u043C\u0435\u043D\u0438\u0442\u044C", javax.microedition.lcdui.Command.OK, 5);
        }
        return cmdEdit;
    }
    
    /**
     * This method returns instance for ticker1 component and should be called instead of accessing ticker1 field directly.
     * @return Instance for ticker1 component
     **/
    private javax.microedition.lcdui.Ticker get_ticker1() {
        if (ticker1 == null) {
            ticker1 = new javax.microedition.lcdui.Ticker("<Enter Ticker Text>");
        }
        return ticker1;
    }
    
    /**
     * This method returns instance for formAlertDelItem component and should be called instead of accessing formAlertDelItem field directly.
     * @return Instance for formAlertDelItem component
     **/
    private javax.microedition.lcdui.Form get_formAlertDelItem() {
        if (formAlertDelItem == null) {
            formAlertDelItem = new javax.microedition.lcdui.Form("\u041F\u043E\u0434\u0442\u0432\u0435\u0440\u0436\u0434\u0435\u043D\u0438\u0435", new javax.microedition.lcdui.Item[] {get_stringItem1()});
            formAlertDelItem.addCommand(get_cmdOk());
            formAlertDelItem.addCommand(get_cmdCancel());
            formAlertDelItem.setCommandListener(this);
        }
        return formAlertDelItem;
    }
    
    /**
     * This method returns instance for stringItem1 component and should be called instead of accessing stringItem1 field directly.
     * @return Instance for stringItem1 component
     **/
    private javax.microedition.lcdui.StringItem get_stringItem1() {
        if (stringItem1 == null) {
            stringItem1 = new javax.microedition.lcdui.StringItem("", "\u041F\u043E\u0441\u043B\u0435\u0434\u043D\u044F\u044F \u0437\u0430\u043F\u0438\u0441\u044C \u0431\u0443\u0434\u0435\u0442 \u0443\u0434\u0430\u043B\u0435\u043D\u0430 \u0438\u0437 \u0441\u043F\u0438\u0441\u043A\u0430. \u041F\u0440\u043E\u0434\u043E\u043B\u0436\u0438\u0442\u044C?");
            stringItem1.setLayout(0x3033);
        }
        return stringItem1;
    }
    
    /**
     * This method returns instance for txtSumm component and should be called instead of accessing txtSumm field directly.
     * @return Instance for txtSumm component
     **/
    private javax.microedition.lcdui.TextField get_txtSumm() {
        if (txtSumm == null) {
            txtSumm = new javax.microedition.lcdui.TextField("\u0421\u0443\u043C\u043C\u0430:", null, 8, 0x5);
            txtSumm.setLayout(0x1e00);
        }
        return txtSumm;
    }
    
    /**
     * This method returns instance for strTotalKmPerDay component and should be called instead of accessing strTotalKmPerDay field directly.
     * @return Instance for strTotalKmPerDay component
     **/
    private javax.microedition.lcdui.StringItem get_strTotalKmPerDay() {
        if (strTotalKmPerDay == null) {
            strTotalKmPerDay = new javax.microedition.lcdui.StringItem("\u0421\u0440. \u0434\u043D\u0435\u0432\u043D\u043E\u0439 \u043F\u0440\u043E\u0431\u0435\u0433", "0");
        }
        return strTotalKmPerDay;
    }
    
    /**
     * This method returns instance for formAbout component and should be called instead of accessing formAbout field directly.
     * @return Instance for formAbout component
     **/
    private javax.microedition.lcdui.Form get_formAbout() {
        if (formAbout == null) {
            formAbout = new javax.microedition.lcdui.Form("\u041E \u041F\u0440\u043E\u0433\u0440\u0430\u043C\u043C\u0435", new javax.microedition.lcdui.Item[] {
                get_stringItem2(),
                        get_stringItem3(),
                        get_stringItem4()
            });
            formAbout.addCommand(get_cmdBack());
            formAbout.setCommandListener(this);
        }
        return formAbout;
    }
    
    /**
     * This method returns instance for stringItem2 component and should be called instead of accessing stringItem2 field directly.
     * @return Instance for stringItem2 component
     **/
    private javax.microedition.lcdui.StringItem get_stringItem2() {
        if (stringItem2 == null) {
            stringItem2 = new javax.microedition.lcdui.StringItem("", "\u0421\u0442\u0430\u0442\u0438\u0441\u0442\u0438\u043A\u0430 \u0437\u0430\u043F\u0440\u0430\u0432\u043E\u043A v1.0");
            stringItem2.setLayout(0x200);
        }
        return stringItem2;
    }
    
    /**
     * This method returns instance for stringItem3 component and should be called instead of accessing stringItem3 field directly.
     * @return Instance for stringItem3 component
     **/
    private javax.microedition.lcdui.StringItem get_stringItem3() {
        if (stringItem3 == null) {
            stringItem3 = new javax.microedition.lcdui.StringItem("\u0421\u0434\u0435\u043B\u0430\u043D\u043E \u0432 iuLabs.com", "(c) \u0418\u0432\u0430\u043D \u0423\u0441\u043A\u043E\u0432, 2006");
        }
        return stringItem3;
    }
    
    /**
     * This method returns instance for stringItem4 component and should be called instead of accessing stringItem4 field directly.
     * @return Instance for stringItem4 component
     **/
    private javax.microedition.lcdui.StringItem get_stringItem4() {
        if (stringItem4 == null) {
            stringItem4 = new javax.microedition.lcdui.StringItem("", " ivus@iulabs.com");
        }
        return stringItem4;
    }
    
    /**
     * This method returns instance for strOpAbout component and should be called instead of accessing strOpAbout field directly.
     * @return Instance for strOpAbout component
     **/
    private javax.microedition.lcdui.StringItem get_strOpAbout() {
        if (strOpAbout == null) {
            strOpAbout = new javax.microedition.lcdui.StringItem("", "\u041E \u043F\u0440\u043E\u0433\u0440\u0430\u043C\u043C\u0435");
            strOpAbout.addCommand(get_cmdOpen());
            strOpAbout.setItemCommandListener(this);
            strOpAbout.setLayout(0x1a03);
        }
        return strOpAbout;
    }
    
    javax.microedition.lcdui.Form formMain;
    javax.microedition.lcdui.StringItem strNewFill;
    javax.microedition.lcdui.Command exitCommand;
    javax.microedition.lcdui.Form formFillEdit;
    javax.microedition.lcdui.TextField txtOdometer;
    javax.microedition.lcdui.Command cmdOk;
    javax.microedition.lcdui.Command cmdCancel;
    javax.microedition.lcdui.TextField txtLiters;
    javax.microedition.lcdui.StringItem strExit;
    javax.microedition.lcdui.TextField txtPrice;
    javax.microedition.lcdui.DateField dtFillDate;
    javax.microedition.lcdui.TextField txtRemark;
    javax.microedition.lcdui.Font fontMonospace;
    javax.microedition.lcdui.List lstRefuels;
    javax.microedition.lcdui.StringItem strRefuelList;
    javax.microedition.lcdui.StringItem strStatistic;
    javax.microedition.lcdui.Command cmdDelItem;
    javax.microedition.lcdui.Form formAlert;
    javax.microedition.lcdui.StringItem strAlertMsg;
    javax.microedition.lcdui.Form formDispRefuel;
    javax.microedition.lcdui.Command cmdBack;
    javax.microedition.lcdui.StringItem strDateOdometer;
    javax.microedition.lcdui.StringItem strPriceLiters;
    javax.microedition.lcdui.StringItem strRemark;
    javax.microedition.lcdui.StringItem strLocalStat;
    javax.microedition.lcdui.Form formStatistic;
    javax.microedition.lcdui.StringItem strTotalRun;
    javax.microedition.lcdui.StringItem strTotalPeriod;
    javax.microedition.lcdui.StringItem strTotalLiter;
    javax.microedition.lcdui.StringItem strTotalConsumption;
    javax.microedition.lcdui.StringItem strTotalCost;
    javax.microedition.lcdui.Command cmdOpen;
    javax.microedition.lcdui.StringItem strOptions;
    javax.microedition.lcdui.Form formOptions;
    javax.microedition.lcdui.StringItem strOptDeleteAll;
    javax.microedition.lcdui.StringItem strOptBack;
    javax.microedition.lcdui.StringItem strTotalOneLiterPrice;
    javax.microedition.lcdui.StringItem strTotalOneKmPrice;
    javax.microedition.lcdui.Command cmdEdit;
    javax.microedition.lcdui.Ticker ticker1;
    javax.microedition.lcdui.Form formAlertDelItem;
    javax.microedition.lcdui.StringItem stringItem1;
    javax.microedition.lcdui.TextField txtSumm;
    javax.microedition.lcdui.StringItem strTotalKmPerDay;
    javax.microedition.lcdui.Form formAbout;
    javax.microedition.lcdui.StringItem stringItem2;
    javax.microedition.lcdui.StringItem stringItem3;
    javax.microedition.lcdui.StringItem stringItem4;
    javax.microedition.lcdui.StringItem strOpAbout;
// --- This is the end of auto-generated section.//</editor-fold>//GEN-END:MVDMethods
    
    public void startApp() 
    {
        initialize();
        LoadFills();
    }
    
    public void pauseApp() {
    }
    
    public void destroyApp(boolean unconditional) 
    {
        saveFills();
    }
    
}
